<?php
namespace RedElementorElements;

class Plugin {

	private static $_instance = null;

	public static function instance() {
		if ( is_null( self::$_instance ) ) {
			self::$_instance = new self();
		}
		return self::$_instance;
	}

	public function widget_scripts() {

	}

	public function css_styles() {
		
	}

	private function include_widgets_files() {	
		require_once( __DIR__ . '/widgets/RedElementorFlipBox.php' );
	}

	public function register_widgets() {
		// Its is now safe to include Widgets files
		$this->include_widgets_files();
		\Elementor\Plugin::instance()->widgets_manager->register_widget_type( new Widgets\RedElementorFlipBox() );
	}
	
	public function add_elementor_widget_categories( $elements_manager ) {

		$elements_manager->add_category(
			'red-elements',
			[
				'title' => 'RED Template',
				'icon' => 'fa fa-plug',
			]
		);

	}

	public function __construct() {
		
		add_action( 'elementor/elements/categories_registered', [ $this, 'add_elementor_widget_categories' ] );

		// Register widget scripts
		add_action( 'elementor/frontend/after_register_scripts', [ $this, 'widget_scripts' ] );
		
		// Register css styles
		add_action( 'elementor/frontend/after_enqueue_styles', [ $this, 'css_styles' ] );

		// Register widgets
		add_action( 'elementor/widgets/widgets_registered', [ $this, 'register_widgets' ] );
	}
}

// Instantiate Plugin Class
Plugin::instance();